From : Max Maischein                                       2:244/1106.17
To   : All                                 
Subj : P5Timer revised                                                       


Hello again !

Today I found this (just great) web-site with an article on pentium
optimization, and I adopted a program from there into the p5 instruction timer.
Here's the (much more stable) result I got. It only delivers stable results
under a clean/himem boot, under NT it simply terminates, under QEMM the results
are more "unpredictable" ...

-max

comment %

This piece of code was very much inspired by a text by Agner Fog,
http://announce.com/agner/assem.htm

I merely added some output for the generated data and some more framework,
so most of the credit should go out to Agner ! You can easily see the
diffference from the coding style, Agner has his code all uppercase, I have
mine all lowercases and indented differently.

I found some problems convincing TASM 3.2 to align the data to a multiple
of 4 - which is why I did it manually, see the filler word below. If QEMM
is active, you have to add about 250 ticks overhead (possibly for cli/sti??)
- for a clean himem boot, I still get an overhead of 1 tick - maybe this
is some oversight on my part, maybe some other strange phenomenon.

I strongly recommend to read the original text where this came from :

http://www.geocities.com/SiliconValley/9498/p5opt.html

22. TESTING SPEED
=================
The Pentium has an internal 64 bit clock counter which can be read into
EDX:EAX using the instruction RDTSC (read time stamp counter). This is very
useful for testing exactly how many clock cycles a piece of code takes.

The program below is useful for measuring the number of clock cycles a piece
of code takes. The program executes the code to test 10 times and stores the
10 clock counts. The program can be used in both 16 and 32 bit mode.

comment %

                        model small
                        .386

RDTSC   MACRO           ; define RDTSC instruction
    DB  0FH,31H
ENDM

ITER    EQU     16              ; number of iterations

.stack 200h

.code

BEGIN:
                        startupcode

TESTLOOP:           ; test loop
;****************   Do any initializations here:    ************************

;****************   End of initializations      ************************
    RDTSC           ; read clock counter
    MOV [TICS],EAX  ; save count
    CLD         ; non-pairable filler
REPT    8
    NOP         ; eight NOP's to avoid shadowing effect
ENDM

;****************   Put instructions to test here:  ************************

;********************* End of instructions to test  ************************

    CLC         ; non-pairable filler with shadow
    RDTSC           ; read counter again
    SUB EAX,[TICS]  ; compute difference
    SUB EAX,15      ; subtract the clock cycles used by fillers etc
        MOV     EDI,[COUNTER]   ; loop counter
        MOV     [RESULTLIST][DI],EAX   ; store result in table
        ADD     EDI,TYPE RESULTLIST     ; increment counter
        MOV     [COUNTER],EDI           ; store counter
        CMP     EDI,ITER * (TYPE RESULTLIST)
    JB  TESTLOOP        ; repeat ITER times

;************************ Deinitialization should take place here **********
                        sti
;************************ End of deinitialization **************************

; insert here code to read out the values in RESULTLIST

                        push    ds
                        pop     es

                        mov     ecx, iter       ; Prepare to output all values
                        xor     esi, esi
NextIteration:
                        mov     eax, ResultList[si]
                        call    OutputEAX       ; Write it to the screen
                        add     esi, 4          ; Move esi to the next value

                        loop    NextIteration

                        exitcode

OutputEAX       proc near
                        mov     edi, offset OutputBuffer
                        push    edi
                        call    DumpEAXDec
                        mov     byte ptr [di], 0        ; Make ASCIIZ

                        pop     edi                     ; Write the string
                        call    WriteLN
                        ret
endp

include io.inc          ; IO routines to output eax to a string buffer

; -------------------------------------
; Data segment
; -------------------------------------

.data

align  2
filler  dw      0               ; The following fields should be dword aligned !

COUNTER DD      0               ; loop counter
TICS    DD      0               ; temporary storage of clock
RESULTLIST  DD  ITER DUP (0)    ; list of test results

; Output section

OutputBuffer db 132 dup (?)     ; Used for string creation

end begin
